"""
this code is modified from 
https://github.com/utkuozbulak/pytorch-cnn-adversarial-attacks
https://github.com/louis2889184/pytorch-adversarial-training
https://github.com/MadryLab/robustness
https://github.com/yaodongyu/TRADES
"""

import torch
import torch.nn.functional as F
# from loss import pairwise_similarity, NT_xent

def project(x, original_x, epsilon, _type='linf'):

    if _type == 'linf':
        max_x = original_x + epsilon
        min_x = original_x - epsilon

        x = torch.max(torch.min(x, max_x), min_x)
    else:
        raise NotImplementedError

    return x



class RepresentationAdv():

    def __init__(self, model, epsilon, alpha, min_val, max_val, max_iters, num_sample,  _type='linf', loss_type='sim', regularize='original',random_start=True):

        # Model
        self.model = model
#         self.projector = projector
        self.regularize = regularize
        # Maximum perturbation
        self.epsilon = epsilon
        # Movement multiplier per iteration
        self.alpha = alpha
        # Minimum value of the pixels
        self.min_val = min_val
        # Maximum value of the pixels
        self.max_val = max_val
        # Maximum numbers of iteration to generated adversaries
        self.max_iters = max_iters
        # The perturbation of epsilon
        self._type = _type
        # number of samples in the same class in a batch
        self.num_sample = num_sample
        # optimizer
#         self.optimizer = optimizer
        # loss type
        self.loss_type = loss_type
        
        self.random_start = random_start
        if self._type == 'l2':
            self.random_start = False
        
        print('attack type: ',self._type)

            
    def get_loss(self, original_images, target, optimizer, weight, random_start=True):
        
        
        x = original_images.clone()

        x.requires_grad = True
        


        return x.detach()

    def attacker_test(self, model ,original_images, target, random_start=True):
        
        
        x = original_images.clone()

        x.requires_grad = True

        
        return x.detach()
    
    def attacker_loss(self, model ,original_images, target,criterion, random_start=True,):
        
	x= original_images.clone()

        x.requires_grad = True


        batch_size = len(x)

        return x.detach()
    
    def smoothing(self, model ,original_images, target, random_start=True, sigma = 0.01):
        
        model.eval()
        output = torch.zeros_like(model(original_images))
        for _iter in range(self.max_iters):
            
            rand_perturb = torch.randn(original_images.shape)
            x = original_images.float().clone() + sigma* rand_perturb.cuda()
            output = output + model(x)

        return output.detach()/self.max_iters